package com.diagbot.entity.node;

import lombok.Data;
import com.diagbot.entity.node.base.BaseNode;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.Labels;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
//@EqualsAndHashCode(callSuper = false)
@NodeEntity(label = "手术和操作")
public class Operation extends BaseNode  {

    @Property(name = "高危级别")
    private String risklevel;

    @Relationship(type = "手术和操作禁忌性别", direction = Relationship.OUTGOING)
    private Gender gender;

    @Relationship(type = "手术和操作禁忌体征", direction = Relationship.OUTGOING)
    private Set<Vital> vitals = new HashSet<>();

    @Relationship(type = "手术和操作禁忌临床表现", direction = Relationship.OUTGOING)
    private Set<ClinicalFinding> clinicalFindings = new HashSet<>();

    @Relationship(type = "手术和操作禁忌实验室检查", direction = Relationship.OUTGOING)
    private Set<LIS> conflict_lis = new HashSet<>();

    @Relationship(type = "手术和操作禁忌辅助检查描述", direction = Relationship.OUTGOING)
    private Set<PACSDescribe> conflict_pacsdesc = new HashSet<>();

    @Relationship(type = "手术和操作禁忌服用药品", direction = Relationship.OUTGOING)
    private Set<OralMedicine> oralMedicines = new HashSet<>();

    @Relationship(type = "手术和操作禁忌疾病", direction = Relationship.OUTGOING)
    private Set<Disease> conflict_diseases = new HashSet<>();

    @Relationship(type = "手术和操作禁忌人群", direction = Relationship.OUTGOING)
    private Set<Group> groups = new HashSet<>();

    @Relationship(type="疾病相关手术和操作", direction = Relationship.INCOMING)
    private Set<Disease> diseases = new HashSet<>();

    @Relationship(type="药品通用名禁忌手术和操作", direction = Relationship.INCOMING)
    private Set<Medicine> medicines = new HashSet<>();

    @Relationship(type="辅助检查禁忌手术和操作", direction = Relationship.INCOMING)
    private Set<PACS> pacs = new HashSet<>();

    @Relationship(type="实验室检查禁忌手术和操作", direction = Relationship.INCOMING)
    private Set<LIS> lis = new HashSet<>();
}


